Public Class wfrmHowTo8_5
    Inherits System.Web.UI.Page
    Protected WithEvents Label1 As System.Web.UI.WebControls.Label
    Protected WithEvents Label3 As System.Web.UI.WebControls.Label
    Protected WithEvents Label4 As System.Web.UI.WebControls.Label
    Protected WithEvents btnSelect As System.Web.UI.WebControls.Button
    Protected WithEvents lstSelected As System.Web.UI.WebControls.ListBox
    Protected WithEvents btnUnSelect As System.Web.UI.WebControls.Button
    Protected WithEvents chkUnAssignedOnly As System.Web.UI.WebControls.CheckBox
    Protected WithEvents lstUnSelected As System.Web.UI.WebControls.ListBox
    Protected WithEvents hplReturnToMain As System.Web.UI.WebControls.HyperLink
    Protected WithEvents ddCategories As System.Web.UI.WebControls.DropDownList

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, _
                    ByVal e As System.EventArgs) Handles MyBase.Load
        'Put user code to initialize the page here

        Dim odaCategories As OleDb.OleDbDataAdapter
        Dim dtCategories As New DataTable()

        '-- Make sure this code is only executed when the page is first loaded.
        If Not Page.IsPostBack Then

            '-- Load up the Categories dropdown control

            odaCategories = New _
                        OleDb.OleDbDataAdapter("Select CategoryID, CategoryName From Categories", _
                        BuildCnnStr("(local)", "Northwind"))

            odaCategories.Fill(dtCategories)

            Me.ddCategories.DataSource = dtCategories
            Me.ddCategories.DataTextField = "CategoryName"
            Me.ddCategories.DataValueField = "CategoryID"

            '-- This is necessary for Web forms, not used on Windows forms.
            Me.ddCategories.DataBind()

            LoadUnSelectedProducts()
            LoadSelectedProducts()

        End If

    End Sub

    Sub LoadUnSelectedProducts()

        Dim odaUnSelected As OleDb.OleDbDataAdapter
        Dim dtUnSelected As New DataTable()
        Dim strSQL As String

        '-- If the check box for unassigned only is checked, then 
        '   grab the product items where the category is NULL, otherwise load 
        '   it up with those products not assigned to the current category.

        If chkUnAssignedOnly.Checked Then
            strSQL = "Select ProductID, ProductName From Products Where CategoryID IS NULL Order By ProductName"
        Else
            strSQL = "Select ProductID, ProductName From Products Where CategoryID <> " & _
                            ddCategories.SelectedItem.Value & " Or CategoryID IS NULL Order By ProductName"
        End If

        '-- Load up the lstUnselected based off the SQL string.

        odaUnSelected = New OleDb.OleDbDataAdapter(strSQL, BuildCnnStr("(local)", "Northwind"))

        odaUnSelected.Fill(dtUnSelected)

        Me.lstUnSelected.Dispose()
        Me.lstUnSelected.DataSource = dtUnSelected
        Me.lstUnSelected.DataTextField = "ProductName"
        Me.lstUnSelected.DataValueField = "ProductID"

        '-- Needed on Web forms.
        Me.lstUnSelected.DataBind()

        Me.lstUnSelected.ClearSelection()

    End Sub

    Sub LoadSelectedProducts()

        Dim odaSelected As OleDb.OleDbDataAdapter
        Dim dtSelected As New DataTable()
        Dim strSQL As String

        '-- Create the SQL string for the category chosen in the ddCategories dropdown.
        '   Then load up datatable with the data, and bind the lstSelected listbox.

        strSQL = "Select ProductID, ProductName From Products Where CategoryID = " & _
                                                ddCategories.SelectedItem.Value & " Order By ProductName"

        odaSelected = New _
                OleDb.OleDbDataAdapter(strSQL, BuildCnnStr("(local)", "Northwind"))

        odaSelected.Fill(dtSelected)

        Me.lstSelected.Dispose()
        Me.lstSelected.DataSource = dtSelected
        Me.lstSelected.DataTextField = "ProductName"
        Me.lstSelected.DataValueField = "ProductID"

        Me.lstSelected.DataBind()
        Me.lstSelected.ClearSelection()

    End Sub


    Private Sub ddCategories_SelectedIndexChanged(ByVal sender As System.Object, _
                        ByVal e As System.EventArgs) Handles ddCategories.SelectedIndexChanged

        LoadUnSelectedProducts()
        LoadSelectedProducts()

    End Sub

    Private Sub btnSelect_Click(ByVal sender As System.Object, _
                            ByVal e As System.EventArgs) Handles btnSelect.Click

        Dim intItemsNum As Integer
        Dim strItems As String
        Dim oCurr As Object

        '-- Iterate through each of the items in lstUnSelected, and check the Selected property.
        '   If selected, store into a string with other selected productid's.

        For Each oCurr In Me.lstUnSelected.Items

            If oCurr.Selected() = True Then

                If Len(strItems) > 0 Then
                    strItems = strItems & ", "
                End If
                strItems = strItems & CType(oCurr.Value, String)

            End If

        Next

        '-- Run an update query to assign the category to the desired products, 
        '   using an IN clause in the SQL statement

        Try
            Dim ocnn As New OleDb.OleDbConnection(BuildCnnStr("(local)", "Northwind"))
            Dim ocmdSelect As New _
                        OleDb.OleDbCommand("Update Products Set CategoryID = " & _
                        Me.ddCategories.SelectedItem.Value & " Where ProductID IN (" & strItems & ")", ocnn)

            ocmdSelect.CommandType = CommandType.Text
            ocnn.Open()
            ocmdSelect.ExecuteNonQuery()

        Catch excpCommand As Exception

        End Try

        LoadUnSelectedProducts()
        LoadSelectedProducts()

    End Sub

    Private Sub btnUnSelect_Click(ByVal sender As System.Object, _
                        ByVal e As System.EventArgs) Handles btnUnSelect.Click

        Dim intItemsNum As Integer
        Dim strItems As String
        Dim oCurr As Object

        '-- Iterate through each of the items in lstSelected, and check the Selected property.
        '   If selected, store into a string with other selected productid's.

        For Each oCurr In Me.lstSelected.Items

            If oCurr.Selected() = True Then

                If Len(strItems) > 0 Then
                    strItems = strItems & ", "
                End If

                strItems = strItems & CType(oCurr.Value, String)

            End If

        Next

        Try

            Dim ocnn As New OleDb.OleDbConnection(BuildCnnStr("(local)", "Northwind"))
            Dim ocmdUnSelect As New _
                    OleDb.OleDbCommand("Update Products Set CategoryID = Null Where ProductID IN (" & _
                    strItems & ")", ocnn)

            ocmdUnSelect.CommandType = CommandType.Text
            ocnn.Open()
            ocmdUnSelect.ExecuteNonQuery()

        Catch excpCommand As Exception
        End Try

        LoadUnSelectedProducts()
        LoadSelectedProducts()


    End Sub

    Private Sub chkUnAssignedOnly_CheckedChanged(ByVal sender As System.Object, _
                        ByVal e As System.EventArgs) Handles chkUnAssignedOnly.CheckedChanged

        LoadUnSelectedProducts()

    End Sub

End Class
