Public Class wfrmHowTo8_7
    Inherits System.Web.UI.Page
    Protected WithEvents lstTables As System.Web.UI.WebControls.ListBox
    Protected WithEvents Label2 As System.Web.UI.WebControls.Label
    Protected WithEvents lstColumns As System.Web.UI.WebControls.ListBox
    Protected WithEvents txtSQLString As System.Web.UI.WebControls.TextBox
    Protected WithEvents Label3 As System.Web.UI.WebControls.Label
    Protected WithEvents Label4 As System.Web.UI.WebControls.Label
    Protected WithEvents btnView As System.Web.UI.WebControls.Button
    Protected WithEvents dgDisplay As System.Web.UI.WebControls.DataGrid
    Protected WithEvents ddSortBy As System.Web.UI.WebControls.DropDownList
    Protected WithEvents Label5 As System.Web.UI.WebControls.Label
    Protected WithEvents hplReturnToMain As System.Web.UI.WebControls.HyperLink
    Protected WithEvents Label1 As System.Web.UI.WebControls.Label

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()

        ViewState("SQLFields") = ""

    End Sub

#End Region
    Private mdtDisplay As DataTable

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'Put user code to initialize the page here

        If Not Me.IsPostBack Then

            LoadTables()

        End If

        If Not (Session("MyDisplayDataTable") Is Nothing) Then

            mdtDisplay = CType(Session("MyDisplayDataTable"), DataTable)

        End If

    End Sub

    Sub LoadTables()

        '-- Create the connection and specify the stored procedure to use.
        Dim ocnn As New OleDb.OleDbConnection(BuildCnnStr("(local)", "Northwind"))
        Dim ocmdTables As New OleDb.OleDbCommand("sp_Tables", ocnn)
        Dim odrTables As OleDb.OleDbDataReader

        '-- Specify the type of command being performed
        ocmdTables.CommandType = CommandType.StoredProcedure

        ocnn.Open()

        '-- Create the datareader object    
        odrTables = ocmdTables.ExecuteReader()

        '-- Loop through and add table type object names to the lstTables listbox.
        Do While odrTables.Read
            If odrTables.GetString(3) = "TABLE" Then
                Me.lstTables.Items.Add(odrTables.GetString(2))
            End If
        Loop

        ocnn.Close()

    End Sub

    Private Sub lstColumns_SelectedIndexChanged(ByVal sender As System.Object, _
                ByVal e As System.EventArgs) Handles lstColumns.SelectedIndexChanged

        Dim intNumColumns As Integer
        Dim oCurr As Object
        Dim blnIsSelected As Boolean
        Dim strTemp As String

        Me.ddSortBy.Items.Clear()

        '-- Cycle through each of the selected columns of the table chosen, 
        '   and combine them into a string

        For Each oCurr In Me.lstColumns.Items

            If oCurr.Selected() = True Then

                If Len(strTemp) > 0 Then
                    strTemp &= ", "
                End If

                strTemp &= oCurr.ToString

                Me.ddSortBy.Items.Add(oCurr.ToString)

            End If
        Next

        ViewState("SQLFields") = strTemp

        LoadSQLString()

    End Sub

    Sub LoadSQLString()

        '-- Take the string created and add it to the table name for a SQL String, 
        '   if columns are chosen.

        If Len(ViewState("SQLFields")) = 0 Then
            Me.txtSQLString.Text = ""
        Else
            Me.txtSQLString.Text = "Select " & ViewState("SQLFields") & " From " & _
                    Me.lstTables.SelectedItem.ToString & " Order By " & Me.ddSortBy.SelectedItem.ToString
        End If

    End Sub

    Private Sub lstTables_SelectedIndexChanged(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles lstTables.SelectedIndexChanged

        '-- Create the connection and specify the stored procedure to use.
        Dim ocnn As New OleDb.OleDbConnection(BuildCnnStr("(local)", "Northwind"))
        Dim ocmdColumns As New OleDb.OleDbCommand("sp_Columns", ocnn)
        Dim odrColumns As OleDb.OleDbDataReader

        '-- Specify the type of command being performed
        ocmdColumns.CommandType = CommandType.StoredProcedure
        ocmdColumns.Parameters.Add("@TableName", Me.lstTables.SelectedItem.Text)

        ocnn.Open()

        '-- Create the datareader object    
        odrColumns = ocmdColumns.ExecuteReader()

        '-- Clear the current items in the list
        Me.lstColumns.Items.Clear()

        '-- Loop through and add table type object names to the lstTables listbox.
        Do While odrColumns.Read
            Me.lstColumns.Items.Add(odrColumns.GetString(3))
        Loop


    End Sub

    Private Sub btnView_Click(ByVal sender As System.Object, _
                            ByVal e As System.EventArgs) Handles btnView.Click
        Dim odaDisplay As OleDb.OleDbDataAdapter
        Dim dtDisplay As New DataTable()

        Try

            '-- Take the txtSQLString text and create datatable, then set the 
            '   datasource of the datagrid.   

            odaDisplay = New OleDb.OleDbDataAdapter(Me.txtSQLString.Text, _
                                                BuildCnnStr("(local)", "Northwind"))

            odaDisplay.Fill(dtDisplay)

            mdtDisplay = dtDisplay

            Session("MyDisplayDataTable") = mdtDisplay

            '-- Must Dispose of old datagrid
            '            Me.dgDisplay.Dispose()

            BindTheGrid()

        Catch excData As Exception

        End Try

    End Sub

    Sub BindTheGrid()

        Me.dgDisplay.DataSource = mdtDisplay
        '-- Must databind for ASP .NET
        Me.dgDisplay.DataBind()

    End Sub

    Private Sub ddSortBy_SelectedIndexChanged(ByVal sender As System.Object, _
                ByVal e As System.EventArgs) Handles ddSortBy.SelectedIndexChanged

        LoadSQLString()

    End Sub


    Private Sub dgDisplay_PageIndexChanged(ByVal source As Object, _
                    ByVal e As System.Web.UI.WebControls.DataGridPageChangedEventArgs) _
                    Handles dgDisplay.PageIndexChanged

        '-- Set the current page in the DataGrid
        Me.dgDisplay.CurrentPageIndex = e.NewPageIndex

        BindTheGrid()


    End Sub

End Class
